Index: src/UIElements/Views/Qt4/QtWorldView.cpp
===================================================================
--- src/UIElements/Views/Qt4/QtWorldView.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Views/Qt4/QtWorldView.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,139 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * QtWorldView.cpp
+ *
+ *  Created on: Jan 21, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Views/Qt4/QtWorldView.hpp"
+
+#include <iostream>
+
+#include "Helpers/MemDebug.hpp"
+
+#include "atom.hpp"
+#include "Formula.hpp"
+#include "molecule.hpp"
+
+using namespace std;
+
+// maybe this should go with the definition of molecules
+
+// some attributes need to be easier to find for molecules
+// these attributes are skiped so far
+const int QtWorldView::COLUMNCOUNT = COLUMNTYPES_MAX;
+const char *QtWorldView::COLUMNNAMES[QtWorldView::COLUMNCOUNT]={"Name","Atoms","Formula"/*,"Size"*/};
+
+QtWorldView::QtWorldView(QWidget * _parent) :
+  QTableWidget (_parent),
+  Observer("QtWorldView")
+{
+  setRowCount(0);
+  setColumnCount(COLUMNCOUNT);
+
+  for(int i=0; i<COLUMNCOUNT;++i) {
+    QTableWidgetItem *heading = new QTableWidgetItem();
+    heading->setText(QString(COLUMNNAMES[i]));
+    setHorizontalHeaderItem(i,heading);
+  }
+
+  molecules = World::getInstance().getMolecules();
+  molecules->signOn(this);
+  update(molecules);
+
+  connect(this,SIGNAL(cellChanged(int,int)),this,SLOT(moleculeChanged(int,int)));
+  connect(this,SIGNAL(cellClicked(int,int)),this,SLOT(cellSelected(int,int)));
+
+}
+
+QtWorldView::~QtWorldView()
+{
+  molecules->signOff(this);
+}
+
+void QtWorldView::update(Observable *publisher) {
+  int numMolecules = molecules->ListOfMolecules.size();
+  setRowCount(numMolecules);
+  molSelection.resize(numMolecules);
+  int i;
+  MoleculeList::iterator iter;
+  for(iter = molecules->ListOfMolecules.begin(),i=0;
+      iter != molecules->ListOfMolecules.end();
+      ++i,++iter) {
+
+    const int index = (*iter)->IndexNr;
+    QTableWidgetItem *indexWidget = new QTableWidgetItem();
+    indexWidget->setText(QString::number(index));
+    indexWidget->setData(Qt::UserRole,QVariant(index));
+    setVerticalHeaderItem(i,indexWidget);
+
+    const string name = (*iter)->getName();
+    QTableWidgetItem *nameWidget = new QTableWidgetItem();
+    nameWidget->setText(QString(name.c_str()));
+    setItem(i,NAME,nameWidget);
+
+    const int atomCount = (*iter)->getAtomCount();
+    QTableWidgetItem *countWidget= new QTableWidgetItem();
+    countWidget->setText(QString::number(atomCount));
+    countWidget->setFlags(Qt::ItemIsSelectable | Qt::ItemIsUserCheckable | Qt::ItemIsEnabled);
+    setItem(i,ATOMS,countWidget);
+
+    const Formula formula = (*iter)->getFormula();
+    QTableWidgetItem *formulaWidget= new QTableWidgetItem();
+    formulaWidget->setText(QString(formula.toString().c_str()));
+    formulaWidget->setFlags(Qt::ItemIsSelectable | Qt::ItemIsUserCheckable | Qt::ItemIsEnabled);
+    setItem(i,ATOMS,formulaWidget);
+
+    molSelection[i]=nameWidget->isSelected();
+  }
+}
+
+void QtWorldView::subjectKilled(Observable *publisher) {
+}
+
+void QtWorldView::moleculeChanged(int row, int column) {
+  int idx = verticalHeaderItem(row)->data(Qt::UserRole).toInt();
+  molecule *mol = molecules->ReturnIndex(idx);
+  string cellValue = item(row,NAME)->text().toStdString();
+  if(mol->getName() != cellValue && cellValue !="") {
+    mol->setName(cellValue);
+  }
+  else if(cellValue==""){
+    item(row,NAME)->setText(QString(mol->getName().c_str()));
+  }
+}
+
+
+void QtWorldView::cellSelected(int row, int column){
+  bool state = item(row,column)->isSelected();
+  for(int i = 0; i<COLUMNCOUNT; i++){
+    item(row,i)->setSelected(state);
+  }
+  // figure out which rows have changed
+  for(int i=0; i<rowCount();++i){
+    state = item(i,0)->isSelected();
+    if(molSelection[i]!=state){
+      int idx = verticalHeaderItem(i)->data(Qt::UserRole).toInt();
+      molecule *mol = molecules->ReturnIndex(idx);
+      if(state){
+        emit moleculeSelected(mol);
+      }
+      else{
+        emit moleculeUnSelected(mol);
+      }
+      molSelection[i]=state;
+    }
+  }
+}
Index: src/UIElements/Views/Qt4/QtWorldView.hpp
===================================================================
--- src/UIElements/Views/Qt4/QtWorldView.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
+++ src/UIElements/Views/Qt4/QtWorldView.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -0,0 +1,47 @@
+/*
+ * QtWorldView.hpp
+ *
+ *  Created on: Jan 21, 2010
+ *      Author: crueger
+ */
+
+#ifndef QTMOLECULESVIEW_HPP_
+#define QTMOLECULESVIEW_HPP_
+
+#include <QtGui/QTableWidget>
+#include "Patterns/Observer.hpp"
+
+class molecule;
+class MoleculeListClass;
+
+class QtWorldView : public QTableWidget, public Observer
+{
+  Q_OBJECT
+
+public:
+  QtWorldView(QWidget * _parent=0);
+  virtual ~QtWorldView();
+
+protected:
+  virtual void update(Observable *publisher);
+  virtual void subjectKilled(Observable *publisher);
+
+  static const int COLUMNCOUNT;
+  enum {NAME,ATOMS,FORMULA,COLUMNTYPES_MAX} COLUMNTYPES;
+  static const char *COLUMNNAMES[];
+
+private slots:
+  void moleculeChanged(int row, int column);
+
+  void cellSelected(int row, int column);
+
+signals:
+  void moleculeSelected(molecule*);
+  void moleculeUnSelected(molecule*);
+
+private:
+  std::vector<bool> molSelection; //!< needed to determine when a selection changes
+  MoleculeListClass *molecules;
+};
+
+#endif /* QTMOLECULESVIEW_HPP_ */
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/builder.cpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -86,5 +86,5 @@
 #include "UIElements/CommandLineUI/CommandLineUIFactory.hpp"
 #ifdef USE_GUI_QT
-#include "UIElements/QT4/QTUIFactory.hpp"
+#include "UIElements/Qt4/QtUIFactory.hpp"
 #endif
 #include "UIElements/MainWindow.hpp"
@@ -184,7 +184,7 @@
       ASSERT_DO(Assert::Ask);
       #ifdef USE_GUI_QT
-        DoLog(0) && (Log() << Verbose(0) << "Setting UI to QT4." << endl);
-        UIFactory::registerFactory(new QTUIFactory::description());
-        UIFactory::makeUserInterface("QT4");
+        DoLog(0) && (Log() << Verbose(0) << "Setting UI to Qt4." << endl);
+        UIFactory::registerFactory(new QtUIFactory::description());
+        UIFactory::makeUserInterface("Qt4");
       #else
         DoLog(0) && (Log() << Verbose(0) << "Setting UI to Text." << endl);
Index: src/unittests/DummyUI.hpp
===================================================================
--- src/unittests/DummyUI.hpp	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/unittests/DummyUI.hpp	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -35,4 +35,5 @@
   virtual void queryElement(const char*, std::string = ""){}
   virtual void queryElements(const char*, std::string = ""){}
+  virtual void queryFile(const char*, std::string = ""){}
 };
 
Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 6940bb556236165ebf89b8495b117042efebb708)
+++ src/unittests/Makefile.am	(revision 573ca5fad13d63566ba36dd8f4507d519d51fa15)
@@ -49,10 +49,10 @@
 noinst_PROGRAMS = $(TESTS) TestRunner
 
+BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB) $(BOOST_PROGRAM_OPTIONS_LIB) $(BOOST_FILESYSTEM_LIB) $(BOOST_THREAD_LIB)
 GSLLIBS = \
 	../LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
 	../Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
 	../Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
-	$(BOOST_LIB) \
-	${BOOST_THREAD_LIB}
+	$(BOOST_LIB)
 ALLLIBS = \
 	../UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la \
@@ -60,6 +60,6 @@
 	${PARSERLIBS} \
 	../libMolecuilder-@MOLECUILDER_API_VERSION@.la \
-	${GSLLIBS} \
-	${BOOST_PROGRAM_OPTIONS_LIB}
+	${GSLLIBS}
+
 PARSERLIBS = ../Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la
 UILIBS = ../UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la  
